#include "stdafx.h"

BOOL CALLBACK VwExportDlgProc( HWND hDlg, UINT iMsg, WPARAM wParam, LPARAM lParam) ;

//-- Global data 
char * g_szTitleExport = "Export Data";
char * g_achVars = "i\0t\0ch0\0ch1\0ch2\0ch3\0ch4\0ch5\0ch6\0ch7\0"
					"ch8\0ch9\0ch10\0ch11\0ch12\0ch13\0ch14\0ch15\0\0";
		
class COptionsExport { 
	public : 
		CString m_cFileName;
		int m_iDataMode;
		int m_iOutputType;
		int m_iChannels;
		bool m_bRepeat;
		int m_iIterations;
		CString m_aEquations[16];
		CExpression m_aExpressions[16];
		
		COptionsExport() { 
			m_cFileName = "Export.qdf";
			m_iDataMode = 0;
			m_iOutputType = 0;
			m_iChannels = 1;
			char buf[16];
			for( int iCh=0; iCh<16; ++iCh ) {
				sprintf( buf, "ch%d", iCh );
				m_aEquations[iCh]=buf;
				}
			}

		void RegistryLoad() { 
			CString c = RegistryLoadString( "OPTIONSEXPORT" ); 
			char chRepeat;
			if( c.Length()>=9 ) { 
				sscanf( c.ConstBuffer(), "%1d%1d%2d%c%3d", 
					&m_iDataMode, &m_iOutputType, &m_iChannels, 
					&chRepeat, &m_iIterations);
				m_bRepeat = ( chRepeat=='Y' || chRepeat=='y' );
				}
			}

		void RegistrySave() { 
			char buf[1024];
			sprintf( buf, "%1d%1d%2d%c%3d", m_iDataMode, m_iOutputType, m_iChannels, 
				m_bRepeat?'Y':'N', min(999,max(0,m_iIterations)) );
			RegistrySaveString( "OPTIONSEXPORT", (char *)buf );
			}
			
	};

COptionsExport g_oOptionsExport;

/*			
	int iLen;
	m_iVars=0;
	char * pch = pchVar;
	do { 
		iLen = strlen(pch);
		pch += iLen+1;
		++m_iVars;
		} while( pch[0]!=0 );
	if( m_iVars==0 ) 
		return true;
		
		
				CString m_cFileName;
		int m_iDataMode;
		int m_iOutputType;
		int m_iChannels;
		bool m_bRepeat;
		int m_iIterations;
		CString m_aEquations[16];
		CExpression m_aExpressions[16];
			//TODO 
			}
*/

//-----------------------------------------------------------------------------
// dialog for options edit 
class CVwExport : public CDialog { 
	private : 
		//-- Controls 
		CDlgCheck m_selDataFile;
		CDlgCheck m_selDataList;
		CDlgCheck m_selDataCurrent;

		CDlgEdit m_edtFileName;		
		CDlgButton m_btnFileSelect;

		CDlgCheck m_selOutputQDF;
		CDlgCheck m_selOutputTXT;
		
		CDlgCombo m_cmbChannels;
		
		CDlgEdit m_edtChanExpr[16];		
		
		CDlgCheck m_chkRepeat;
		CDlgEdit m_edtIterations;
		
		CDlgButton m_btnSaveEqns;
		CDlgButton m_btnLoadEqns;
		
		bool m_bDataCurrent;
		bool m_bDataList;
		bool m_bSetup;
		
	public : 		
		CVwExport( ) {
			m_iID = IDD_DLG_EXPORT;
			m_bDataCurrent = true;
			m_bDataList = true;
			m_bSetup = false;
			}
	
		~CVwExport() { 
			}

		//-- Initialize controls 
		void InitializeControls( ) { 
			m_cmbChannels.SetHandle( GetDlgItem(m_hDlg, IDC_SELCHANNEL), "Count of data channels in the export file");

			m_selDataFile.SetHandle( GetDlgItem(m_hDlg, IDC_DATASEL1), "Export entire file");
			m_selDataList.SetHandle( GetDlgItem(m_hDlg, IDC_DATASEL2), "Export current selection list only");
			m_selDataCurrent.SetHandle( GetDlgItem(m_hDlg, IDC_DATASEL3), "Export current selection only");
			
			m_edtFileName.SetHandle( GetDlgItem(m_hDlg, IDC_EDTFILENAME), "File name to export to");
			m_btnFileSelect.SetHandle( GetDlgItem(m_hDlg, IDC_BTNFILESELECT), "Open file selection dialogue");

			m_selOutputQDF.SetHandle( GetDlgItem(m_hDlg,IDC_SELQDF ), "Export to .qdf qub compatible data fomat");
			m_selOutputTXT.SetHandle( GetDlgItem(m_hDlg,IDC_SELASCII ), "Export to ascii text file");

			for( int iCh=0; iCh<16; ++iCh ) 
				m_edtChanExpr[iCh].SetHandle( GetDlgItem(m_hDlg,IDC_EDTCHAN00+iCh ), "Enter an expression as a function of iteration i, data channels ch0, ch1, ... and time t\n Example : 'ch3' or 'ch4+10+5*i' ");

			m_chkRepeat.SetHandle( GetDlgItem(m_hDlg,IDC_CHKREPEAT ), "Export the data multiple times to single file (at least one export expression should be a function of i)");
			m_edtIterations.SetHandle( GetDlgItem(m_hDlg,IDC_EDTITERATIONS ), "Number of times to export the data");

			m_btnSaveEqns.SetHandle( GetDlgItem(m_hDlg,IDC_BTNSAVEEQNS ), "Save expressions to a text file");
			m_btnLoadEqns.SetHandle( GetDlgItem(m_hDlg,IDC_BTNLOADEQNS ), "Load expressions from a text file");

			if( ! m_bDataCurrent  )
				EnableWindow( m_selDataCurrent.GetHandle(), false );
			if( ! m_bDataList ) 
				EnableWindow( m_selDataList.GetHandle(), false );
			m_bSetup=true;
			OnChangeChannels();
			}

		//-- Set all control contents and disable unused rows
		void SetControlValues( COptionsExport * pOpt ) { 
			//-- data - whole file, selection list, current selection 
			if( pOpt->m_iDataMode==2 && m_bDataCurrent ) 
				m_selDataCurrent.SetCheck(true);
			else if( pOpt->m_iDataMode==1 && m_bDataList ) 
				m_selDataList.SetCheck(true);
			else 
				m_selDataFile.SetCheck(true);

			//-- Channel counts
			char buf[64];
			m_cmbChannels.ClearContents();
			for( int iCh=1; iCh<=16; ++iCh ) {
				sprintf( buf, "%d", iCh );
				m_cmbChannels.AddString(buf);
				}
			m_cmbChannels.SetCurSel( pOpt->m_iChannels-1 );
			OnChangeChannels();
			
			//-- File Name 
			m_edtFileName.SetText( pOpt->m_cFileName.ConstBuffer() );
			
			//-- Output Type 
			if( pOpt->m_iOutputType==0 ) 
				m_selOutputQDF.SetCheck(true);
			else 
				m_selOutputTXT.SetCheck(true);
			
			//-- Channels , expressions
			m_cmbChannels.SetCurSel(max(1,min(16,pOpt->m_iChannels))-1);
			for( int iCh=0; iCh<16; ++iCh )
				m_edtChanExpr[iCh].SetText( pOpt->m_aEquations[iCh].ConstBuffer() );
				
			//-- Repeat
			m_chkRepeat.SetCheck( pOpt->m_bRepeat );
			m_edtIterations.SetTextInt( pOpt->m_iIterations );
			}

		//-----------------------------------------------------------------------------
		bool GetControlValues( COptionsExport * pOpt ) { 
			//-- Get selected data 
			if( m_selDataCurrent.GetCheck() ) 
				pOpt->m_iDataMode=2;
			else if( m_selDataList.GetCheck() )
				pOpt->m_iDataMode=1;
			else if( m_selDataFile.GetCheck() ) 
				pOpt->m_iDataMode=0;
			else { 
				MessageBox( m_hDlg, "You must select a data option", g_szTitleExport, MB_OK );
				return false;
				}
				
			//-- File name
			m_edtFileName.GetText( &pOpt->m_cFileName );

			//-- Output Type 
			pOpt->m_iOutputType = m_selOutputTXT.GetCheck() ? 1 : 0;

			//-- get channel count, expressions
			pOpt->m_iChannels = m_cmbChannels.GetCurSel()+1;
			if( pOpt->m_iChannels<0 || pOpt->m_iChannels>16 ) { 
				MessageBox( m_hDlg, "Channel count error", g_szTitleExport, MB_OK );
				return false;
				}
			for( int iCh=0; iCh<16; ++iCh )
				m_edtChanExpr[iCh].GetText( &(pOpt->m_aEquations[iCh]) );
				
			//-- Repeat
			pOpt->m_bRepeat = m_chkRepeat.GetCheck( );
			pOpt->m_iIterations = m_edtIterations.GetTextInt( );

			//-- parse expressions
			for( int iCh=0; iCh<16; ++iCh )
				if( ! pOpt->m_aExpressions[iCh].Parse( pOpt->m_aEquations[iCh].ConstBuffer(), g_achVars ) ) {
					char buf[128];
					sprintf( buf, "Error parsing expression for channel %d", iCh );
					MessageBox( m_hDlg, buf, g_szTitleExport, MB_OK );
					return false;
					}			

			return true;
			}

		//-----------------------------------------------------------------------------
		// Events and messages 

		//-- [SAVE] 
		void OnOK( ) { 
			if( GetControlValues( &g_oOptionsExport ) ) 
				EndDialog( m_hDlg, IDOK );
			}
			
		//-- [CANCEL]  
		void OnBtnCancel( ) { 
			EndDialog( m_hDlg, IDCANCEL );
			}
			
		void OnSaveEqn( COptionsExport * pOpt ) { 
			char achLongName[_MAX_PATH]={0};
			char achFileName[_MAX_PATH]={0};
			if( ! GetSaveFileName( achLongName, 
									"Ascii Files (*.txt)\0*.txt\0All Files (*.*)\0*.*\0\0", 
									"txt", GetParent(m_hDlg), achFileName ) ) 
				return;

			CString cFileName(achLongName);
			CString c(m_cmbChannels.GetCurSel()+1);
			CStringArray ac;
			ac.AddString(c.ConstBuffer());
			for( int i=0; i<16; ++i ) {
				m_edtChanExpr[i].GetText( &c );
				ac.AddString( c.ConstBuffer() );
				}
			
			if( ! StringsToFile( &ac, cFileName.ConstBuffer(), 17 ) ) {
				MessageBox( m_hDlg, "Error exporting expressions.", g_szTitleExport, MB_OK );
				return;
				}
			}

		void OnLoadEqn( COptionsExport * pOpt ) { 
			char achLongName[_MAX_PATH]={0};
			char achFileName[_MAX_PATH]={0};
			if( ! GetOpenFileName( achLongName, 
									"Ascii Files (*.txt)\0*.txt\0All Files (*.*)\0*.*\0\0", 
									"txt", GetParent(m_hDlg), achFileName ) ) 
				return;

			CString cFileName(achLongName);

			CStringArray ac;
			if( ! StringsFromFile( &ac, cFileName.ConstBuffer(), 17 ) ) {
				MessageBox( m_hDlg, "Error exporting expressions.", g_szTitleExport, MB_OK );
				return;
				}
			m_cmbChannels.SetCurSel( max(0,min(16,atoi(ac[0].ConstBuffer())-1)) );
			OnChangeChannels();
			for( int i=0; i<16 && i<ac.Count(); ++i )
				m_edtChanExpr[i].SetText( ac[i+1].ConstBuffer() );
			
			}
			
		void DisableDataCurrent() { 
			m_bDataCurrent=false;
			}

		void DisableDataList() { 
			m_bDataList = false;
			}
			
		void OnChangeChannels() { 
			if( ! m_bSetup ) 
				return;
			int iChannels = m_cmbChannels.GetCurSel();
			for( int iCh=0; iCh<16; ++iCh )
				m_edtChanExpr[iCh].SetEnabled( iCh<=iChannels );
			
			}
			
		void OnFileSelect() {	
			//-- select the file to load 
			char achLongName[_MAX_PATH]={0};
			char achFileName[_MAX_PATH]={0};
			m_edtFileName.GetText( achLongName, _MAX_PATH );
			if( ! GetSaveFileName( achLongName, 
							"Text Files (*.txt)\0*.txt\0All Files (*.*)\0*.*\0\0", 
							"txt", GetParent(m_hDlg), achFileName ) ) 
				return;
			m_edtFileName.SetText( achLongName );
			}
			
	};

//-----------------------------------------------------------------------------
CVwExport * g_pVwExport;		// Modal - one and only instance

//-----------------------------------------------------------------------------
void OpenVwExport( HWND hDlgVwData, CData * pData, bool bList, bool bSelect ) { 
	//-- Attempt to lock data 
	if( ! pData->SetStatus(1) ) {
		MessageBox( hDlgVwData, "The data is currently in use by another task.", g_szTitleExport, MB_OK );
		return;
		}
	
	//-- create dialogue to get task options.  Remove unavailable options.
	g_pVwExport = new CVwExport;
	if( ! bSelect ) 
		g_pVwExport->DisableDataCurrent();	
	if( ! bList ) 
		g_pVwExport->DisableDataList();		

	//-- Set default channel count
	g_oOptionsExport.m_iChannels = pData->m_oConfig.ChannelCount();

	//-- attempt load of last export options from registry 				
	g_oOptionsExport.RegistryLoad();

	//-- present dialogue
	if( IDOK != DialogBox( GetInstance(), (LPCTSTR)IDD_DLG_EXPORT, hDlgVwData, (DLGPROC)VwExportDlgProc ) ) {
		//-- if [Cancel]
		pData->SetStatus(0);
		return;
		}
			
	//-- if [OK]			
	g_oOptionsExport.RegistrySave();
	
	//-- dataset setup
	CSelectionSet oSelSet;
	bool lSetSetup=false;
	lSetSetup = oSelSet.Setup( hDlgVwData, g_oOptionsExport.m_iDataMode, pData, -1 );
	
	if( ! lSetSetup ) {						// if dataset was not obtainable
		MessageBox( hDlgVwData, "Error setting data source", g_szTitleExport, MB_OK);
		pData->SetStatus(0);
		return;
		}
	
	//-- Export Data ( non - threaded ) 
	int iIteration, iIterations = g_oOptionsExport.m_bRepeat ? g_oOptionsExport.m_iIterations : 0;
	int iCh, iChannels=min(16,pData->m_oConfig.ChannelCount());
	int iExpr, iExprs=g_oOptionsExport.m_iChannels;
	int iSample, iSamples;
	double adVar[18];

	//-- File Export 
	if( g_oOptionsExport.m_iOutputType==1 ) {			// Asciii text file
		
		//-- create output file 
		FILE * h = fopen( g_oOptionsExport.m_cFileName.ConstBuffer(), "w+");
		if( h == NULL ) { 
			pData->SetStatus(0);
			return;
			}

		//-- iterate through data
		double dEval;
		for( iIteration=0; iIteration<=iIterations; ++iIteration ) {
			adVar[0]=double(iIteration);
			if( oSelSet.GetFirst() ) 
				do { 
					iSamples=oSelSet.CurrentSize();
					for( iSample=0; iSample<iSamples; ++iSample ) { 
						//-- copy data to buffer 
						adVar[1] = oSelSet.m_pRange->m_dtStart-oSelSet.m_pRange->m_dtStart0 + oSelSet.m_pData->m_dSampling * iSample;
						for( iCh=0; iCh<iChannels; ++iCh )
							adVar[2+iCh]=oSelSet.Datum(iCh,iSample);
						//-- evaluate expressions
						for( iExpr=0; iExpr<iExprs; ++iExpr ) {
							dEval=g_oOptionsExport.m_aExpressions[iExpr].Evaluate( adVar );
							fprintf( h, iExpr==iExprs-1?"%f\n":"%f,", dEval );
							}
						}
					} while( oSelSet.GetNext() );
					
			//-- separate iterations by blank line 
			fprintf( h, "\n" );
			}

		//-- close output file 
		fclose(h);
		}
		
	else if( g_oOptionsExport.m_iOutputType==0 ) {		// qdf file 
		//-- create the new data view 
		COptionsNewData oConfig;
		oConfig.m_cFileName = g_oOptionsExport.m_cFileName;
		oConfig.m_dScaling=pData->m_dScaling;
		oConfig.m_dSampling=pData->m_dSampling;
		oConfig.m_iPointsPerTrace=pData->m_oConfig.m_iPointsPerTrace;
		oConfig.m_iTracesPerPage=pData->m_oConfig.m_iTracesPerPage;
		oConfig.m_iChannelCount=g_oOptionsExport.m_iChannels;

		HWND hwndDataNew = OpenDataView( oConfig.m_cFileName.ConstBuffer() );
		SendMessage( hwndDataNew, WM_DATA_CREATENEW, (WPARAM)&oConfig, 0 );	

		for( iExpr=0; iExpr<iExprs; ++iExpr ) { 
			int iVar=g_oOptionsExport.m_aExpressions[iExpr].FindVar(2,17);
			if( iVar>=0 )
				PostMessage( hwndDataNew, WM_DATA_CHANNELINFO, (WPARAM)iExpr, 
						(LPARAM)pData->m_oConfig.Channel(iVar-2)->m_cUnits.ConstBuffer() );
			}


		//-- iterate through data
		double * adData;
		for( iIteration=0; iIteration<=iIterations; ++iIteration ) {
			adVar[0]=double(iIteration);
			if( oSelSet.GetFirst() ) 
				do { 
					iSamples=oSelSet.CurrentSize();
					adData = new double[iSamples*iExprs];
					for( iSample=0; iSample<iSamples; ++iSample ) { 
						//-- copy data to input variables buffer 
						adVar[1] = oSelSet.m_pRange->m_dtStart-oSelSet.m_pRange->m_dtStart0 +  oSelSet.m_pData->m_dSampling * iSample;
						for( iCh=0; iCh<iChannels; ++iCh )
							adVar[2+iCh]=oSelSet.Datum(iCh,iSample);
						//-- evaluate expressions
						for( iExpr=0; iExpr<iExprs; ++iExpr ) 
							adData[iSample*iExprs+iExpr]=g_oOptionsExport.m_aExpressions[iExpr].Evaluate( adVar );
						}
						
					PostMessage( hwndDataNew, WM_DATA_ADDSEGMENT, (WPARAM)iSamples, (LPARAM)adData );
					} while( oSelSet.GetNext() );
			}
		}
		
	pData->SetStatus(0);
	}

//-----------------------------------------------------------------------------
// Message Pump
BOOL CALLBACK VwExportDlgProc( HWND hDlg, UINT iMsg, WPARAM wParam, LPARAM lParam) { 
	int wmId, wmEvent;
	
	switch( iMsg ) { 
		//----- DIALOG INIT -  Control Initialization
		case WM_INITDIALOG :		
			g_pVwExport->m_hDlg=hDlg;			
			
			//-- Clear Existing  Values
			g_pVwExport->InitializeControls();
			g_pVwExport->SetControlValues( &g_oOptionsExport );

			return TRUE;

		//----- MENU and CONTROL Commands
		case WM_COMMAND : 
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 

			switch( wmId ) { 
				case IDOK :					//-- [OK]
					g_pVwExport->OnOK( );
					break;

				case IDCANCEL :				//-- [CANCEL]
					g_pVwExport->OnBtnCancel( );
					break;
				
				case IDC_BTNFILESELECT : 
					g_pVwExport->OnFileSelect();
					break;

				case IDC_BTNSAVEEQNS : 
					g_pVwExport->OnSaveEqn(&g_oOptionsExport);
					break;

				case IDC_BTNLOADEQNS : 
					g_pVwExport->OnLoadEqn(&g_oOptionsExport);
					break;

				case IDC_SELCHANNEL :
					if( wmEvent==CBN_SELCHANGE )
						g_pVwExport->OnChangeChannels();
					break;

				}
				
			return TRUE;

		case WM_DESTROY : 
			delete g_pVwExport;
			WindowListRemove( hDlg );
			return TRUE;
			
		default : 
			break;
		}
	return FALSE;
	} 

